/* ToolButtonWithMenu.c generated by valac 0.18.1, the Vala compiler
 * generated from ToolButtonWithMenu.vala, do not modify */

/*
 * Copyright (c) 2011 Mathijs Henquet
 *
 * Marlin is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Marlin is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authors:
 *      Mathijs Henquet <mathijs.henquet@gmail.com>
 *      ammonkey <am.monkeyd@gmail.com>
 *
 */
/*
 * ToolButtonWithMenu
 * - support long click / right click with depressed button states
 * - activate a GtkAction if any or popup a menu.
 * (used in history navigation buttons next/prev, appmenu)
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>


#define GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU (granite_widgets_tool_button_with_menu_get_type ())
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu))
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuClass))
#define GRANITE_WIDGETS_IS_TOOL_BUTTON_WITH_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU))
#define GRANITE_WIDGETS_IS_TOOL_BUTTON_WITH_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU))
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuClass))

typedef struct _GraniteWidgetsToolButtonWithMenu GraniteWidgetsToolButtonWithMenu;
typedef struct _GraniteWidgetsToolButtonWithMenuClass GraniteWidgetsToolButtonWithMenuClass;
typedef struct _GraniteWidgetsToolButtonWithMenuPrivate GraniteWidgetsToolButtonWithMenuPrivate;

#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_TYPE_MENU_POSITION (granite_widgets_tool_button_with_menu_menu_position_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

typedef enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_CENTER,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_LEFT,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_RIGHT,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_INSIDE_WINDOW
} GraniteWidgetsToolButtonWithMenuMenuPosition;

struct _GraniteWidgetsToolButtonWithMenu {
	GtkToggleToolButton parent_instance;
	GraniteWidgetsToolButtonWithMenuPrivate * priv;
	GtkAction* myaction;
	gulong toggled_sig_id;
	GraniteWidgetsToolButtonWithMenuMenuPosition menu_position;
};

struct _GraniteWidgetsToolButtonWithMenuClass {
	GtkToggleToolButtonClass parent_class;
};

typedef GtkMenu* (*GraniteWidgetsToolButtonWithMenuMenuFetcher) (void* user_data);
struct _GraniteWidgetsToolButtonWithMenuPrivate {
	gint LONG_PRESS_TIME;
	gint timeout;
	guint last_click_time;
	gboolean has_fetcher;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _fetcher;
	gpointer _fetcher_target;
	GtkMenu* _menu;
	GtkButton* button;
};

struct _Block12Data {
	int _ref_count_;
	GraniteWidgetsToolButtonWithMenu * self;
	GdkEventButton ev;
};


static gpointer granite_widgets_tool_button_with_menu_parent_class = NULL;

GType granite_widgets_tool_button_with_menu_get_type (void) G_GNUC_CONST;
GType granite_widgets_tool_button_with_menu_menu_position_get_type (void) G_GNUC_CONST;
#define GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenuPrivate))
enum  {
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_DUMMY_PROPERTY,
	GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU
};
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_action (GtkAction* action);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_action (GType object_type, GtkAction* action);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_stock (const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_stock (GType object_type, const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new (GtkImage* image, const gchar* label, GtkMenu* _menu, GraniteWidgetsToolButtonWithMenuMenuPosition menu_position);
GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct (GType object_type, GtkImage* image, const gchar* label, GtkMenu* _menu, GraniteWidgetsToolButtonWithMenuMenuPosition menu_position);
static void granite_widgets_tool_button_with_menu_update_menu_properties (GraniteWidgetsToolButtonWithMenu* self);
GtkMenu* granite_widgets_tool_button_with_menu_get_menu (GraniteWidgetsToolButtonWithMenu* self);
static void __lambda15_ (GraniteWidgetsToolButtonWithMenu* self);
static void granite_widgets_tool_button_with_menu_deactivate_menu (GraniteWidgetsToolButtonWithMenu* self);
static void ___lambda15__gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self);
void granite_widgets_tool_button_with_menu_popdown_menu (GraniteWidgetsToolButtonWithMenu* self);
static void _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self);
void granite_widgets_tool_button_with_menu_set_menu (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* value);
static gboolean granite_widgets_tool_button_with_menu_on_mnemonic_activate (GraniteWidgetsToolButtonWithMenu* self, gboolean group_cycling);
static gboolean _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self);
static gboolean granite_widgets_tool_button_with_menu_on_button_press_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static gboolean _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean granite_widgets_tool_button_with_menu_on_button_release_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static gboolean _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void granite_widgets_tool_button_with_menu_real_show_all (GtkWidget* base);
static void granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
void granite_widgets_tool_button_with_menu_popup_menu (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static gboolean ___lambda16_ (Block12Data* _data12_);
static gboolean ____lambda16__gsource_func (gpointer self);
static void granite_widgets_tool_button_with_menu_fetch_menu (GraniteWidgetsToolButtonWithMenu* self);
static void granite_widgets_tool_button_with_menu_get_menu_position (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in);
static void _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self);
GraniteWidgetsToolButtonWithMenuMenuFetcher granite_widgets_tool_button_with_menu_get_fetcher (GraniteWidgetsToolButtonWithMenu* self, gpointer* result_target);
void granite_widgets_tool_button_with_menu_set_fetcher (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuMenuFetcher value, gpointer value_target);
static void granite_widgets_tool_button_with_menu_finalize (GObject* obj);
static void _vala_granite_widgets_tool_button_with_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_granite_widgets_tool_button_with_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
         * MenuPosition:
         * CENTER: Center-align the menu relative to the button's position.
         * LEFT: Left-align the menu relative to the button's position.
         * RIGHT: Right-align the menu relative to the button's position.
         * INSIDE_WINDOW: Keep the menu inside the GtkWindow. Center-align when possible.
         **/
GType granite_widgets_tool_button_with_menu_menu_position_get_type (void) {
	static volatile gsize granite_widgets_tool_button_with_menu_menu_position_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_tool_button_with_menu_menu_position_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_CENTER, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_CENTER", "center"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_LEFT, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_LEFT", "left"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_RIGHT, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_RIGHT", "right"}, {GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_INSIDE_WINDOW, "GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_INSIDE_WINDOW", "inside-window"}, {0, NULL, NULL}};
		GType granite_widgets_tool_button_with_menu_menu_position_type_id;
		granite_widgets_tool_button_with_menu_menu_position_type_id = g_enum_register_static ("GraniteWidgetsToolButtonWithMenuMenuPosition", values);
		g_once_init_leave (&granite_widgets_tool_button_with_menu_menu_position_type_id__volatile, granite_widgets_tool_button_with_menu_menu_position_type_id);
	}
	return granite_widgets_tool_button_with_menu_menu_position_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_action (GType object_type, GtkAction* action) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	GtkAction* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkAction* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkAction* _tmp8_;
	GtkAction* _tmp9_;
	GtkAction* _tmp10_;
	GtkAction* _tmp11_;
	g_return_val_if_fail (action != NULL, NULL);
	_tmp0_ = action;
	_tmp1_ = gtk_action_get_stock_id (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = action;
	_tmp4_ = gtk_action_get_label (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	self = (GraniteWidgetsToolButtonWithMenu*) granite_widgets_tool_button_with_menu_construct_from_stock (object_type, _tmp2_, GTK_ICON_SIZE_MENU, _tmp5_, _tmp7_);
	_g_object_unref0 (_tmp7_);
	gtk_activatable_set_use_action_appearance ((GtkActivatable*) self, TRUE);
	_tmp8_ = action;
	gtk_activatable_set_related_action ((GtkActivatable*) self, _tmp8_);
	_tmp9_ = action;
	GTK_ACTION_GET_CLASS (_tmp9_)->connect_proxy (_tmp9_, (GtkWidget*) self);
	_tmp10_ = action;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	_g_object_unref0 (self->myaction);
	self->myaction = _tmp11_;
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_action (GtkAction* action) {
	return granite_widgets_tool_button_with_menu_construct_from_action (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, action);
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct_from_stock (GType object_type, const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	const gchar* _tmp0_;
	GtkIconSize _tmp1_;
	GtkImage* _tmp2_;
	GtkImage* image;
	const gchar* _tmp3_;
	GtkMenu* _tmp4_;
	g_return_val_if_fail (stock_image != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (menu != NULL, NULL);
	_tmp0_ = stock_image;
	_tmp1_ = size;
	_tmp2_ = (GtkImage*) gtk_image_new_from_stock (_tmp0_, _tmp1_);
	g_object_ref_sink (_tmp2_);
	image = _tmp2_;
	_tmp3_ = label;
	_tmp4_ = menu;
	self = (GraniteWidgetsToolButtonWithMenu*) granite_widgets_tool_button_with_menu_construct (object_type, image, _tmp3_, _tmp4_, GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_CENTER);
	_g_object_unref0 (image);
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new_from_stock (const gchar* stock_image, GtkIconSize size, const gchar* label, GtkMenu* menu) {
	return granite_widgets_tool_button_with_menu_construct_from_stock (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, stock_image, size, label, menu);
}


static void __lambda15_ (GraniteWidgetsToolButtonWithMenu* self) {
	granite_widgets_tool_button_with_menu_deactivate_menu (self);
}


static void ___lambda15__gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self) {
	__lambda15_ (self);
}


static void _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate (GtkMenuShell* _sender, gpointer self) {
	granite_widgets_tool_button_with_menu_popdown_menu (self);
}


static void granite_widgets_tool_button_with_menu_update_menu_properties (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkMenu* _tmp4_;
	GtkMenu* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_menu_attach_to_widget (_tmp1_, (GtkWidget*) self, NULL);
	_tmp2_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp3_ = _tmp2_;
	g_signal_connect_object ((GtkMenuShell*) _tmp3_, "deactivate", (GCallback) ___lambda15__gtk_menu_shell_deactivate, self, 0);
	_tmp4_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp5_ = _tmp4_;
	g_signal_connect_object ((GtkMenuShell*) _tmp5_, "deactivate", (GCallback) _granite_widgets_tool_button_with_menu_popdown_menu_gtk_menu_shell_deactivate, self, 0);
}


static gboolean _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate (GtkWidget* _sender, gboolean group_cycling, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_mnemonic_activate (self, group_cycling);
	return result;
}


static gboolean _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_button_press_event (self, event);
	return result;
}


static gboolean _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = granite_widgets_tool_button_with_menu_on_button_release_event (self, event);
	return result;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_construct (GType object_type, GtkImage* image, const gchar* label, GtkMenu* _menu, GraniteWidgetsToolButtonWithMenuMenuPosition menu_position) {
	GraniteWidgetsToolButtonWithMenu * self = NULL;
	GraniteWidgetsToolButtonWithMenuMenuPosition _tmp0_;
	GtkImage* _tmp1_;
	const gchar* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	const gchar* _tmp7_;
	GtkMenu* _tmp8_;
	GtkWidget* _tmp9_ = NULL;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GdkEventMask _tmp13_;
	GdkEventMask _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	g_return_val_if_fail (image != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (_menu != NULL, NULL);
	self = (GraniteWidgetsToolButtonWithMenu*) g_object_new (object_type, NULL);
	_tmp0_ = menu_position;
	self->menu_position = _tmp0_;
	_tmp1_ = image;
	gtk_tool_button_set_icon_widget ((GtkToolButton*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = label;
	_tmp3_ = (GtkLabel*) gtk_label_new (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_tool_button_set_label_widget ((GtkToolButton*) self, (GtkWidget*) _tmp4_);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = gtk_tool_button_get_label_widget ((GtkToolButton*) self);
	_tmp6_ = _tmp5_;
	gtk_label_set_use_underline (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GTK_TYPE_LABEL) ? ((GtkLabel*) _tmp6_) : NULL, TRUE);
	g_object_set ((GtkWidget*) self, "can-focus", TRUE, NULL);
	_tmp7_ = label;
	gtk_tool_item_set_tooltip_text ((GtkToolItem*) self, _tmp7_);
	_tmp8_ = _menu;
	granite_widgets_tool_button_with_menu_set_menu (self, _tmp8_);
	g_signal_connect_object ((GtkWidget*) self, "mnemonic-activate", (GCallback) _granite_widgets_tool_button_with_menu_on_mnemonic_activate_gtk_widget_mnemonic_activate, self, 0);
	_tmp9_ = gtk_bin_get_child ((GtkBin*) self);
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, GTK_TYPE_BUTTON) ? ((GtkButton*) _tmp9_) : NULL);
	_g_object_unref0 (self->priv->button);
	self->priv->button = _tmp10_;
	_tmp11_ = self->priv->button;
	_tmp12_ = self->priv->button;
	_tmp13_ = gtk_widget_get_events ((GtkWidget*) _tmp12_);
	_tmp14_ = _tmp13_;
	gtk_widget_set_events ((GtkWidget*) _tmp12_, _tmp14_ | (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
	_tmp15_ = self->priv->button;
	g_signal_connect_object ((GtkWidget*) _tmp15_, "button-press-event", (GCallback) _granite_widgets_tool_button_with_menu_on_button_press_event_gtk_widget_button_press_event, self, 0);
	_tmp16_ = self->priv->button;
	g_signal_connect_object ((GtkWidget*) _tmp16_, "button-release-event", (GCallback) _granite_widgets_tool_button_with_menu_on_button_release_event_gtk_widget_button_release_event, self, 0);
	return self;
}


GraniteWidgetsToolButtonWithMenu* granite_widgets_tool_button_with_menu_new (GtkImage* image, const gchar* label, GtkMenu* _menu, GraniteWidgetsToolButtonWithMenuMenuPosition menu_position) {
	return granite_widgets_tool_button_with_menu_construct (GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, image, label, _menu, menu_position);
}


static void granite_widgets_tool_button_with_menu_real_show_all (GtkWidget* base) {
	GraniteWidgetsToolButtonWithMenu * self;
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	self = (GraniteWidgetsToolButtonWithMenu*) base;
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
	GTK_WIDGET_CLASS (granite_widgets_tool_button_with_menu_parent_class)->show_all ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_TOGGLE_TOOL_BUTTON, GtkToggleToolButton));
}


static void granite_widgets_tool_button_with_menu_deactivate_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkAction* _tmp0_;
	GtkAction* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->myaction;
	if (_tmp0_ != NULL) {
		GtkAction* _tmp1_;
		_tmp1_ = self->myaction;
		gtk_action_block_activate (_tmp1_);
	}
	gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, FALSE);
	_tmp2_ = self->myaction;
	if (_tmp2_ != NULL) {
		GtkAction* _tmp3_;
		_tmp3_ = self->myaction;
		gtk_action_unblock_activate (_tmp3_);
	}
}


static void granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	GtkAction* _tmp0_;
	GtkAction* _tmp2_;
	GdkEventButton _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->myaction;
	if (_tmp0_ != NULL) {
		GtkAction* _tmp1_;
		_tmp1_ = self->myaction;
		gtk_action_block_activate (_tmp1_);
	}
	gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, TRUE);
	_tmp2_ = self->myaction;
	if (_tmp2_ != NULL) {
		GtkAction* _tmp3_;
		_tmp3_ = self->myaction;
		gtk_action_unblock_activate (_tmp3_);
	}
	_tmp4_ = *ev;
	granite_widgets_tool_button_with_menu_popup_menu (self, &_tmp4_);
}


static gboolean granite_widgets_tool_button_with_menu_on_button_release_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	guint32 _tmp1_;
	guint _tmp2_;
	gint _tmp3_;
	gint _tmp7_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	_tmp0_ = *ev;
	_tmp1_ = _tmp0_.time;
	_tmp2_ = self->priv->last_click_time;
	_tmp3_ = self->priv->LONG_PRESS_TIME;
	if ((_tmp1_ - _tmp2_) < ((guint32) _tmp3_)) {
		GtkAction* _tmp4_;
		_tmp4_ = self->myaction;
		if (_tmp4_ != NULL) {
			GtkAction* _tmp5_;
			_tmp5_ = self->myaction;
			gtk_action_activate (_tmp5_);
		} else {
			GdkEventButton _tmp6_;
			gtk_toggle_tool_button_set_active ((GtkToggleToolButton*) self, TRUE);
			_tmp6_ = *ev;
			granite_widgets_tool_button_with_menu_popup_menu (self, &_tmp6_);
		}
	}
	_tmp7_ = self->priv->timeout;
	if (_tmp7_ != (-1)) {
		gint _tmp8_;
		_tmp8_ = self->priv->timeout;
		g_source_remove ((guint) _tmp8_);
		self->priv->timeout = -1;
	}
	result = TRUE;
	return result;
}


static Block12Data* block12_data_ref (Block12Data* _data12_) {
	g_atomic_int_inc (&_data12_->_ref_count_);
	return _data12_;
}


static void block12_data_unref (void * _userdata_) {
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
		GraniteWidgetsToolButtonWithMenu * self;
		self = _data12_->self;
		_g_object_unref0 (self);
		g_slice_free (Block12Data, _data12_);
	}
}


static gboolean ___lambda16_ (Block12Data* _data12_) {
	GraniteWidgetsToolButtonWithMenu * self;
	gboolean result = FALSE;
	GdkEventButton _tmp0_;
	self = _data12_->self;
	self->priv->timeout = -1;
	_tmp0_ = _data12_->ev;
	granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (self, &_tmp0_);
	result = FALSE;
	return result;
}


static gboolean ____lambda16__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda16_ (self);
	return result;
}


static gboolean granite_widgets_tool_button_with_menu_on_button_press_event (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean result = FALSE;
	Block12Data* _data12_;
	GdkEventButton _tmp0_;
	gint _tmp1_ = 0;
	GtkAction* _tmp2_;
	gint _tmp4_;
	gint max_press_time;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gboolean _tmp9_;
	GdkEventButton _tmp14_;
	guint _tmp15_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ev != NULL, FALSE);
	_data12_ = g_slice_new0 (Block12Data);
	_data12_->_ref_count_ = 1;
	_data12_->self = g_object_ref (self);
	_tmp0_ = *ev;
	_data12_->ev = _tmp0_;
	_tmp2_ = self->myaction;
	if (_tmp2_ != NULL) {
		gint _tmp3_;
		_tmp3_ = self->priv->LONG_PRESS_TIME;
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = 0;
	}
	_tmp4_ = _tmp1_;
	max_press_time = _tmp4_;
	_tmp6_ = self->priv->timeout;
	if (_tmp6_ == (-1)) {
		GdkEventButton _tmp7_;
		guint _tmp8_;
		_tmp7_ = _data12_->ev;
		_tmp8_ = _tmp7_.button;
		_tmp5_ = _tmp8_ == ((guint) 1);
	} else {
		_tmp5_ = FALSE;
	}
	_tmp9_ = _tmp5_;
	if (_tmp9_) {
		GdkEventButton _tmp10_;
		guint32 _tmp11_;
		gint _tmp12_;
		guint _tmp13_ = 0U;
		_tmp10_ = _data12_->ev;
		_tmp11_ = _tmp10_.time;
		self->priv->last_click_time = (guint) _tmp11_;
		_tmp12_ = max_press_time;
		_tmp13_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp12_, ____lambda16__gsource_func, block12_data_ref (_data12_), block12_data_unref);
		self->priv->timeout = (gint) _tmp13_;
	}
	_tmp14_ = _data12_->ev;
	_tmp15_ = _tmp14_.button;
	if (_tmp15_ == ((guint) 3)) {
		GdkEventButton _tmp16_;
		GtkAction* _tmp17_;
		_tmp16_ = _data12_->ev;
		g_signal_emit_by_name (self, "right-click", &_tmp16_);
		_tmp17_ = self->myaction;
		if (_tmp17_ != NULL) {
			GdkEventButton _tmp18_;
			_tmp18_ = _data12_->ev;
			granite_widgets_tool_button_with_menu_popup_menu_and_depress_button (self, &_tmp18_);
		}
	}
	result = TRUE;
	block12_data_unref (_data12_);
	_data12_ = NULL;
	return result;
}


static gboolean granite_widgets_tool_button_with_menu_on_mnemonic_activate (GraniteWidgetsToolButtonWithMenu* self, gboolean group_cycling) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = group_cycling;
	if (!_tmp0_) {
		gtk_widget_activate ((GtkWidget*) self);
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_;
		g_object_get ((GtkWidget*) self, "can-focus", &_tmp1_, NULL);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			gtk_widget_grab_focus ((GtkWidget*) self);
		}
	}
	result = TRUE;
	return result;
}


static void _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func (GtkMenu* menu, gint* x, gint* y, gboolean* push_in, gpointer self) {
	granite_widgets_tool_button_with_menu_get_menu_position (self, menu, x, y, push_in);
}


void granite_widgets_tool_button_with_menu_popup_menu (GraniteWidgetsToolButtonWithMenu* self, GdkEventButton* ev) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->has_fetcher;
	if (_tmp0_) {
		granite_widgets_tool_button_with_menu_fetch_menu (self);
	}
	{
		guint _tmp1_ = 0U;
		GdkEventButton* _tmp2_;
		guint32 _tmp5_ = 0U;
		GdkEventButton* _tmp6_;
		GtkMenu* _tmp10_;
		GtkMenu* _tmp11_;
		guint _tmp12_;
		guint32 _tmp13_;
		_tmp2_ = ev;
		if (_tmp2_ == NULL) {
			_tmp1_ = (guint) 0;
		} else {
			GdkEventButton* _tmp3_;
			guint _tmp4_;
			_tmp3_ = ev;
			_tmp4_ = (*_tmp3_).button;
			_tmp1_ = _tmp4_;
		}
		_tmp6_ = ev;
		if (_tmp6_ == NULL) {
			guint32 _tmp7_ = 0U;
			_tmp7_ = gtk_get_current_event_time ();
			_tmp5_ = _tmp7_;
		} else {
			GdkEventButton* _tmp8_;
			guint32 _tmp9_;
			_tmp8_ = ev;
			_tmp9_ = (*_tmp8_).time;
			_tmp5_ = _tmp9_;
		}
		_tmp10_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp1_;
		_tmp13_ = _tmp5_;
		gtk_menu_popup (_tmp11_, NULL, NULL, _granite_widgets_tool_button_with_menu_get_menu_position_gtk_menu_position_func, self, _tmp12_, _tmp13_);
	}
	__finally24:
	{
		GtkMenu* _tmp14_;
		GtkMenu* _tmp15_;
		GtkWidget* _tmp16_ = NULL;
		GtkWidget* _tmp17_;
		GtkWidget* _tmp18_;
		gboolean _tmp19_;
		GtkMenu* _tmp25_;
		GtkMenu* _tmp26_;
		_tmp14_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp15_ = _tmp14_;
		g_object_get (_tmp15_, "attach-widget", &_tmp16_, NULL);
		_tmp17_ = _tmp16_;
		_tmp18_ = _tmp17_;
		_tmp19_ = _tmp18_ != NULL;
		_g_object_unref0 (_tmp18_);
		if (_tmp19_) {
			GtkMenu* _tmp20_;
			GtkMenu* _tmp21_;
			GtkWidget* _tmp22_ = NULL;
			GtkWidget* _tmp23_;
			GtkWidget* _tmp24_;
			_tmp20_ = granite_widgets_tool_button_with_menu_get_menu (self);
			_tmp21_ = _tmp20_;
			g_object_get (_tmp21_, "attach-widget", &_tmp22_, NULL);
			_tmp23_ = _tmp22_;
			_tmp24_ = _tmp23_;
			gtk_widget_set_state_flags (_tmp24_, GTK_STATE_FLAG_SELECTED, TRUE);
			_g_object_unref0 (_tmp24_);
		}
		_tmp25_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp26_ = _tmp25_;
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp26_, FALSE);
	}
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


void granite_widgets_tool_button_with_menu_popdown_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkWidget* _tmp4_ = NULL;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp1_ = _tmp0_;
	gtk_menu_popdown (_tmp1_);
	_tmp2_ = granite_widgets_tool_button_with_menu_get_menu (self);
	_tmp3_ = _tmp2_;
	g_object_get (_tmp3_, "attach-widget", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_ != NULL;
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		GtkMenu* _tmp8_;
		GtkMenu* _tmp9_;
		GtkWidget* _tmp10_ = NULL;
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
		_tmp8_ = granite_widgets_tool_button_with_menu_get_menu (self);
		_tmp9_ = _tmp8_;
		g_object_get (_tmp9_, "attach-widget", &_tmp10_, NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_;
		gtk_widget_set_state_flags (_tmp12_, GTK_STATE_FLAG_NORMAL, TRUE);
		_g_object_unref0 (_tmp12_);
	}
}


static void granite_widgets_tool_button_with_menu_fetch_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp1_;
	void* _tmp1__target;
	GtkMenu* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = granite_widgets_tool_button_with_menu_get_fetcher (self, &_tmp0__target);
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	_tmp2_ = _tmp1_ (_tmp1__target);
	_g_object_unref0 (self->priv->_menu);
	self->priv->_menu = _tmp2_;
	granite_widgets_tool_button_with_menu_update_menu_properties (self);
}


static void granite_widgets_tool_button_with_menu_get_menu_position (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* menu, gint* x, gint* y, gboolean* push_in) {
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _vala_push_in = FALSE;
	GtkAllocation menu_allocation = {0};
	GtkMenu* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GtkMenu* _tmp3_;
	GtkWidget* _tmp4_ = NULL;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp13_;
	GtkMenu* _tmp14_;
	GtkWidget* _tmp15_ = NULL;
	GtkWidget* _tmp16_;
	GtkWidget* _tmp17_;
	GdkWindow* _tmp18_ = NULL;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
	GtkAllocation allocation = {0};
	GtkMenu* _tmp21_;
	GtkWidget* _tmp22_ = NULL;
	GtkWidget* _tmp23_;
	GtkWidget* _tmp24_;
	GtkAllocation _tmp25_ = {0};
	GraniteWidgetsToolButtonWithMenuMenuPosition _tmp26_;
	gint width = 0;
	gint height = 0;
	GtkMenu* _tmp46_;
	gint _tmp47_ = 0;
	gint _tmp48_ = 0;
	GraniteWidgetsToolButtonWithMenuMenuPosition _tmp49_;
	gint _tmp72_;
	GtkAllocation _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	GtkMenu* _tmp77_;
	GtkWidget* _tmp78_ = NULL;
	GtkWidget* _tmp79_;
	GtkWidget* _tmp80_;
	GdkScreen* _tmp81_ = NULL;
	gint _tmp82_ = 0;
	gboolean _tmp83_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (menu != NULL);
	_tmp0_ = menu;
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
	menu_allocation = _tmp1_;
	_tmp3_ = menu;
	g_object_get (_tmp3_, "attach-widget", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_ == NULL;
	_g_object_unref0 (_tmp6_);
	if (_tmp7_) {
		_tmp2_ = TRUE;
	} else {
		GtkMenu* _tmp8_;
		GtkWidget* _tmp9_ = NULL;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		GdkWindow* _tmp12_ = NULL;
		_tmp8_ = menu;
		g_object_get (_tmp8_, "attach-widget", &_tmp9_, NULL);
		_tmp10_ = _tmp9_;
		_tmp11_ = _tmp10_;
		_tmp12_ = gtk_widget_get_window (_tmp11_);
		_tmp2_ = _tmp12_ == NULL;
		_g_object_unref0 (_tmp11_);
	}
	_tmp13_ = _tmp2_;
	if (_tmp13_) {
		_vala_x = 0;
		_vala_y = 0;
		_vala_push_in = TRUE;
		if (x) {
			*x = _vala_x;
		}
		if (y) {
			*y = _vala_y;
		}
		if (push_in) {
			*push_in = _vala_push_in;
		}
		return;
	}
	_tmp14_ = menu;
	g_object_get (_tmp14_, "attach-widget", &_tmp15_, NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = _tmp16_;
	_tmp18_ = gtk_widget_get_window (_tmp17_);
	gdk_window_get_origin (_tmp18_, &_tmp19_, &_tmp20_);
	_vala_x = _tmp19_;
	_vala_y = _tmp20_;
	_g_object_unref0 (_tmp17_);
	_tmp21_ = menu;
	g_object_get (_tmp21_, "attach-widget", &_tmp22_, NULL);
	_tmp23_ = _tmp22_;
	_tmp24_ = _tmp23_;
	gtk_widget_get_allocation (_tmp24_, &_tmp25_);
	allocation = _tmp25_;
	_g_object_unref0 (_tmp24_);
	_tmp26_ = self->menu_position;
	if (_tmp26_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_RIGHT) {
		gint _tmp27_;
		GtkAllocation _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		GtkAllocation _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		GtkAllocation _tmp34_;
		gint _tmp35_;
		_tmp27_ = _vala_x;
		_tmp28_ = allocation;
		_tmp29_ = _tmp28_.x;
		_vala_x = _tmp27_ + _tmp29_;
		_tmp30_ = _vala_x;
		_tmp31_ = menu_allocation;
		_tmp32_ = _tmp31_.width;
		_vala_x = _tmp30_ - _tmp32_;
		_tmp33_ = _vala_x;
		_tmp34_ = allocation;
		_tmp35_ = _tmp34_.width;
		_vala_x = _tmp33_ + _tmp35_;
	} else {
		GraniteWidgetsToolButtonWithMenuMenuPosition _tmp36_;
		_tmp36_ = self->menu_position;
		if (_tmp36_ != GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_LEFT) {
			gint _tmp37_;
			GtkAllocation _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			GtkAllocation _tmp41_;
			gint _tmp42_;
			gint _tmp43_;
			GtkAllocation _tmp44_;
			gint _tmp45_;
			_tmp37_ = _vala_x;
			_tmp38_ = allocation;
			_tmp39_ = _tmp38_.x;
			_vala_x = _tmp37_ + _tmp39_;
			_tmp40_ = _vala_x;
			_tmp41_ = menu_allocation;
			_tmp42_ = _tmp41_.width;
			_vala_x = _tmp40_ - (_tmp42_ / 2);
			_tmp43_ = _vala_x;
			_tmp44_ = allocation;
			_tmp45_ = _tmp44_.width;
			_vala_x = _tmp43_ + (_tmp45_ / 2);
		}
	}
	_tmp46_ = menu;
	gtk_widget_get_size_request ((GtkWidget*) _tmp46_, &_tmp47_, &_tmp48_);
	width = _tmp47_;
	height = _tmp48_;
	_tmp49_ = self->menu_position;
	if (_tmp49_ == GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU_POSITION_INSIDE_WINDOW) {
		GtkWidget* _tmp50_ = NULL;
		GtkWidget* _tmp51_;
		GtkWidget* parent_widget;
		GtkAllocation window_allocation = {0};
		GtkWidget* _tmp52_;
		GtkAllocation _tmp53_ = {0};
		GtkWidget* _tmp54_;
		GdkWindow* _tmp55_ = NULL;
		gint _tmp56_ = 0;
		gint _tmp57_ = 0;
		gint _tmp58_;
		gint parent_window_x0;
		gint _tmp59_;
		GtkAllocation _tmp60_;
		gint _tmp61_;
		gint parent_window_xf;
		gint _tmp62_;
		GtkAllocation _tmp63_;
		gint _tmp64_;
		gint _tmp65_;
		gint _tmp69_;
		gint _tmp70_;
		_tmp50_ = gtk_widget_get_toplevel ((GtkWidget*) self);
		_tmp51_ = _g_object_ref0 (_tmp50_);
		parent_widget = _tmp51_;
		_tmp52_ = parent_widget;
		gtk_widget_get_allocation (_tmp52_, &_tmp53_);
		window_allocation = _tmp53_;
		_tmp54_ = parent_widget;
		_tmp55_ = gtk_widget_get_window (_tmp54_);
		gdk_window_get_origin (_tmp55_, &_tmp56_, &_tmp57_);
		_vala_x = _tmp56_;
		_vala_y = _tmp57_;
		_tmp58_ = _vala_x;
		parent_window_x0 = _tmp58_;
		_tmp59_ = parent_window_x0;
		_tmp60_ = window_allocation;
		_tmp61_ = _tmp60_.width;
		parent_window_xf = _tmp59_ + _tmp61_;
		_tmp62_ = _vala_x;
		_tmp63_ = menu_allocation;
		_tmp64_ = _tmp63_.width;
		_tmp65_ = parent_window_xf;
		if ((_tmp62_ + _tmp64_) > _tmp65_) {
			gint _tmp66_;
			GtkAllocation _tmp67_;
			gint _tmp68_;
			_tmp66_ = parent_window_xf;
			_tmp67_ = menu_allocation;
			_tmp68_ = _tmp67_.width;
			_vala_x = _tmp66_ - _tmp68_;
		}
		_tmp69_ = _vala_x;
		_tmp70_ = parent_window_x0;
		if (_tmp69_ < _tmp70_) {
			gint _tmp71_;
			_tmp71_ = parent_window_x0;
			_vala_x = _tmp71_;
		}
		_g_object_unref0 (parent_widget);
	}
	_tmp72_ = _vala_y;
	_tmp73_ = allocation;
	_tmp74_ = _tmp73_.y;
	_vala_y = _tmp72_ + _tmp74_;
	_tmp75_ = _vala_y;
	_tmp76_ = height;
	_tmp77_ = menu;
	g_object_get (_tmp77_, "attach-widget", &_tmp78_, NULL);
	_tmp79_ = _tmp78_;
	_tmp80_ = _tmp79_;
	_tmp81_ = gtk_widget_get_screen (_tmp80_);
	_tmp82_ = gdk_screen_get_height (_tmp81_);
	_tmp83_ = (_tmp75_ + _tmp76_) >= _tmp82_;
	_g_object_unref0 (_tmp80_);
	if (_tmp83_) {
		gint _tmp84_;
		gint _tmp85_;
		_tmp84_ = _vala_y;
		_tmp85_ = height;
		_vala_y = _tmp84_ - _tmp85_;
	} else {
		gint _tmp86_;
		GtkAllocation _tmp87_;
		gint _tmp88_;
		_tmp86_ = _vala_y;
		_tmp87_ = allocation;
		_tmp88_ = _tmp87_.height;
		_vala_y = _tmp86_ + _tmp88_;
	}
	_vala_push_in = TRUE;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (push_in) {
		*push_in = _vala_push_in;
	}
}


GraniteWidgetsToolButtonWithMenuMenuFetcher granite_widgets_tool_button_with_menu_get_fetcher (GraniteWidgetsToolButtonWithMenu* self, gpointer* result_target) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher result;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp1_;
	void* _tmp1__target;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_fetcher;
	_tmp0__target = self->priv->_fetcher_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_fetcher (GraniteWidgetsToolButtonWithMenu* self, GraniteWidgetsToolButtonWithMenuMenuFetcher value, gpointer value_target) {
	GraniteWidgetsToolButtonWithMenuMenuFetcher _tmp0_;
	void* _tmp0__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	self->priv->_fetcher = _tmp0_;
	self->priv->_fetcher_target = _tmp0__target;
	self->priv->has_fetcher = TRUE;
}


GtkMenu* granite_widgets_tool_button_with_menu_get_menu (GraniteWidgetsToolButtonWithMenu* self) {
	GtkMenu* result;
	GtkMenu* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_menu;
	result = _tmp0_;
	return result;
}


void granite_widgets_tool_button_with_menu_set_menu (GraniteWidgetsToolButtonWithMenu* self, GtkMenu* value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->has_fetcher;
	if (_tmp0_) {
		g_warning ("ToolButtonWithMenu.vala:79: Don't set the menu property on a ToolMenuB" \
"utton when there is already a menu fetcher");
	} else {
		GtkMenu* _tmp1_;
		GtkMenu* _tmp2_;
		_tmp1_ = value;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (self->priv->_menu);
		self->priv->_menu = _tmp2_;
		granite_widgets_tool_button_with_menu_update_menu_properties (self);
	}
	g_object_notify ((GObject *) self, "menu");
}


static void granite_widgets_tool_button_with_menu_class_init (GraniteWidgetsToolButtonWithMenuClass * klass) {
	granite_widgets_tool_button_with_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GraniteWidgetsToolButtonWithMenuPrivate));
	GTK_WIDGET_CLASS (klass)->show_all = granite_widgets_tool_button_with_menu_real_show_all;
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_tool_button_with_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_tool_button_with_menu_set_property;
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_tool_button_with_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU, g_param_spec_object ("menu", "menu", "menu", GTK_TYPE_MENU, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("right_click", GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
}


static void granite_widgets_tool_button_with_menu_instance_init (GraniteWidgetsToolButtonWithMenu * self) {
	GtkSettings* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_;
	self->priv = GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_GET_PRIVATE (self);
	_tmp0_ = gtk_settings_get_default ();
	g_object_get (_tmp0_, "gtk-double-click-time", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	self->priv->LONG_PRESS_TIME = _tmp2_ * 2;
	self->priv->timeout = -1;
	self->priv->last_click_time = (guint) (-1);
	self->priv->has_fetcher = FALSE;
}


static void granite_widgets_tool_button_with_menu_finalize (GObject* obj) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	_g_object_unref0 (self->myaction);
	_g_object_unref0 (self->priv->_menu);
	_g_object_unref0 (self->priv->button);
	G_OBJECT_CLASS (granite_widgets_tool_button_with_menu_parent_class)->finalize (obj);
}


GType granite_widgets_tool_button_with_menu_get_type (void) {
	static volatile gsize granite_widgets_tool_button_with_menu_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_tool_button_with_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsToolButtonWithMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_tool_button_with_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsToolButtonWithMenu), 0, (GInstanceInitFunc) granite_widgets_tool_button_with_menu_instance_init, NULL };
		GType granite_widgets_tool_button_with_menu_type_id;
		granite_widgets_tool_button_with_menu_type_id = g_type_register_static (GTK_TYPE_TOGGLE_TOOL_BUTTON, "GraniteWidgetsToolButtonWithMenu", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_tool_button_with_menu_type_id__volatile, granite_widgets_tool_button_with_menu_type_id);
	}
	return granite_widgets_tool_button_with_menu_type_id__volatile;
}


static void _vala_granite_widgets_tool_button_with_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	switch (property_id) {
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU:
		g_value_set_object (value, granite_widgets_tool_button_with_menu_get_menu (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_granite_widgets_tool_button_with_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GraniteWidgetsToolButtonWithMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_TOOL_BUTTON_WITH_MENU, GraniteWidgetsToolButtonWithMenu);
	switch (property_id) {
		case GRANITE_WIDGETS_TOOL_BUTTON_WITH_MENU_MENU:
		granite_widgets_tool_button_with_menu_set_menu (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



