/* Utils.c generated by valac 0.18.1, the Vala compiler
 * generated from Utils.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*
 * Copyright (c) 2012 Granite Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define GRANITE_TYPE_TEXT_STYLE (granite_text_style_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	GRANITE_TEXT_STYLE_TITLE,
	GRANITE_TEXT_STYLE_H1,
	GRANITE_TEXT_STYLE_H2,
	GRANITE_TEXT_STYLE_H3
} GraniteTextStyle;



GType granite_text_style_get_type (void) G_GNUC_CONST;
gchar* granite_text_style_get_stylesheet (GraniteTextStyle self, gchar** style_class);
GdkPixbuf* get_close_pixbuf (void);
GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget, const gchar* stylesheet, const gchar* class_name, gint priority);
GtkCssProvider* granite_widgets_utils_get_css_provider (const gchar* stylesheet);
GtkCssProvider* granite_widgets_utils_set_theming_for_screen (GdkScreen* screen, const gchar* stylesheet, gint priority);
void granite_widgets_utils_apply_text_style_to_label (GraniteTextStyle text_style, GtkLabel* label);


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


gchar* granite_text_style_get_stylesheet (GraniteTextStyle self, gchar** style_class) {
	gchar* _vala_style_class = NULL;
	gchar* result = NULL;
	switch (self) {
		case GRANITE_TEXT_STYLE_TITLE:
		{
			gchar* _tmp0_;
			const gchar* _tmp1_;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
			_tmp0_ = g_strdup ("title");
			_g_free0 (_vala_style_class);
			_vala_style_class = _tmp0_;
			_tmp1_ = _vala_style_class;
			_tmp2_ = string_to_string (_tmp1_);
			_tmp3_ = g_strconcat (".", _tmp2_, " { font: raleway 36; }", NULL);
			result = _tmp3_;
			if (style_class) {
				*style_class = _vala_style_class;
			} else {
				_g_free0 (_vala_style_class);
			}
			return result;
		}
		case GRANITE_TEXT_STYLE_H1:
		{
			gchar* _tmp4_;
			const gchar* _tmp5_;
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			_tmp4_ = g_strdup ("h1");
			_g_free0 (_vala_style_class);
			_vala_style_class = _tmp4_;
			_tmp5_ = _vala_style_class;
			_tmp6_ = string_to_string (_tmp5_);
			_tmp7_ = g_strconcat (".", _tmp6_, " { font: open sans bold 24; }", NULL);
			result = _tmp7_;
			if (style_class) {
				*style_class = _vala_style_class;
			} else {
				_g_free0 (_vala_style_class);
			}
			return result;
		}
		case GRANITE_TEXT_STYLE_H2:
		{
			gchar* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			_tmp8_ = g_strdup ("h2");
			_g_free0 (_vala_style_class);
			_vala_style_class = _tmp8_;
			_tmp9_ = _vala_style_class;
			_tmp10_ = string_to_string (_tmp9_);
			_tmp11_ = g_strconcat (".", _tmp10_, " { font: open sans light 18; }", NULL);
			result = _tmp11_;
			if (style_class) {
				*style_class = _vala_style_class;
			} else {
				_g_free0 (_vala_style_class);
			}
			return result;
		}
		case GRANITE_TEXT_STYLE_H3:
		{
			gchar* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_ = NULL;
			gchar* _tmp15_ = NULL;
			_tmp12_ = g_strdup ("h3");
			_g_free0 (_vala_style_class);
			_vala_style_class = _tmp12_;
			_tmp13_ = _vala_style_class;
			_tmp14_ = string_to_string (_tmp13_);
			_tmp15_ = g_strconcat (".", _tmp14_, " { font: open sans bold 12; }", NULL);
			result = _tmp15_;
			if (style_class) {
				*style_class = _vala_style_class;
			} else {
				_g_free0 (_vala_style_class);
			}
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
	if (style_class) {
		*style_class = _vala_style_class;
	} else {
		_g_free0 (_vala_style_class);
	}
}


GType granite_text_style_get_type (void) {
	static volatile gsize granite_text_style_type_id__volatile = 0;
	if (g_once_init_enter (&granite_text_style_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_TEXT_STYLE_TITLE, "GRANITE_TEXT_STYLE_TITLE", "title"}, {GRANITE_TEXT_STYLE_H1, "GRANITE_TEXT_STYLE_H1", "h1"}, {GRANITE_TEXT_STYLE_H2, "GRANITE_TEXT_STYLE_H2", "h2"}, {GRANITE_TEXT_STYLE_H3, "GRANITE_TEXT_STYLE_H3", "h3"}, {0, NULL, NULL}};
		GType granite_text_style_type_id;
		granite_text_style_type_id = g_enum_register_static ("GraniteTextStyle", values);
		g_once_init_leave (&granite_text_style_type_id__volatile, granite_text_style_type_id);
	}
	return granite_text_style_type_id__volatile;
}


/**
     * Applies the stylesheet to the widget
     */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


GtkCssProvider* granite_widgets_utils_set_theming (GtkWidget* widget, const gchar* stylesheet, const gchar* class_name, gint priority) {
	GtkCssProvider* result = NULL;
	const gchar* _tmp0_;
	GtkCssProvider* _tmp1_ = NULL;
	GtkCssProvider* css_provider;
	GtkWidget* _tmp2_;
	GtkStyleContext* _tmp3_ = NULL;
	GtkStyleContext* _tmp4_;
	GtkStyleContext* context;
	GtkCssProvider* _tmp5_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	gboolean _tmp14_;
	g_return_val_if_fail (widget != NULL, NULL);
	g_return_val_if_fail (stylesheet != NULL, NULL);
	_tmp0_ = stylesheet;
	_tmp1_ = granite_widgets_utils_get_css_provider (_tmp0_);
	css_provider = _tmp1_;
	_tmp2_ = widget;
	_tmp3_ = gtk_widget_get_style_context (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	context = _tmp4_;
	_tmp5_ = css_provider;
	if (_tmp5_ != NULL) {
		GtkStyleContext* _tmp6_;
		GtkCssProvider* _tmp7_;
		gint _tmp8_;
		_tmp6_ = context;
		_tmp7_ = css_provider;
		_tmp8_ = priority;
		gtk_style_context_add_provider (_tmp6_, (GtkStyleProvider*) _tmp7_, (guint) _tmp8_);
	}
	_tmp10_ = class_name;
	if (_tmp10_ != NULL) {
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		_tmp11_ = class_name;
		_tmp12_ = string_strip (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp9_ = g_strcmp0 (_tmp13_, "") != 0;
		_g_free0 (_tmp13_);
	} else {
		_tmp9_ = FALSE;
	}
	_tmp14_ = _tmp9_;
	if (_tmp14_) {
		GtkStyleContext* _tmp15_;
		const gchar* _tmp16_;
		_tmp15_ = context;
		_tmp16_ = class_name;
		gtk_style_context_add_class (_tmp15_, _tmp16_);
	}
	result = css_provider;
	_g_object_unref0 (context);
	return result;
}


/**
     * Applies a stylesheet to the given screen. This will affects all the
     * widgets which are part of that screen.
     */
GtkCssProvider* granite_widgets_utils_set_theming_for_screen (GdkScreen* screen, const gchar* stylesheet, gint priority) {
	GtkCssProvider* result = NULL;
	const gchar* _tmp0_;
	GtkCssProvider* _tmp1_ = NULL;
	GtkCssProvider* css_provider;
	GtkCssProvider* _tmp2_;
	g_return_val_if_fail (screen != NULL, NULL);
	g_return_val_if_fail (stylesheet != NULL, NULL);
	_tmp0_ = stylesheet;
	_tmp1_ = granite_widgets_utils_get_css_provider (_tmp0_);
	css_provider = _tmp1_;
	_tmp2_ = css_provider;
	if (_tmp2_ != NULL) {
		GdkScreen* _tmp3_;
		GtkCssProvider* _tmp4_;
		gint _tmp5_;
		_tmp3_ = screen;
		_tmp4_ = css_provider;
		_tmp5_ = priority;
		gtk_style_context_add_provider_for_screen (_tmp3_, (GtkStyleProvider*) _tmp4_, (guint) _tmp5_);
	}
	result = css_provider;
	return result;
}


/**
     * @return a new {@link Gtk.CssProvider}, or null in case the parsing of
     *         @stylesheet failed.
     */
GtkCssProvider* granite_widgets_utils_get_css_provider (const gchar* stylesheet) {
	GtkCssProvider* result = NULL;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* provider;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (stylesheet != NULL, NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	{
		GtkCssProvider* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = provider;
		_tmp2_ = stylesheet;
		gtk_css_provider_load_from_data (_tmp1_, _tmp2_, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch20_g_error;
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		_tmp5_ = stylesheet;
		g_warning ("Utils.vala:95: Could not create CSS Provider: %s\nStylesheet:\n%s", _tmp4_, _tmp5_);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (provider);
		return result;
	}
	__finally20:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = provider;
	return result;
}


/**
     * Text Style
     */
void granite_widgets_utils_apply_text_style_to_label (GraniteTextStyle text_style, GtkLabel* label) {
	GtkCssProvider* _tmp0_;
	GtkCssProvider* style_provider;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_ = NULL;
	GtkStyleContext* _tmp3_;
	GtkStyleContext* style_context;
	gchar* style_class = NULL;
	gchar* stylesheet = NULL;
	GraniteTextStyle _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GtkStyleContext* _tmp7_;
	const gchar* _tmp8_;
	GtkStyleContext* _tmp13_;
	GtkCssProvider* _tmp14_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (label != NULL);
	_tmp0_ = gtk_css_provider_new ();
	style_provider = _tmp0_;
	_tmp1_ = label;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	style_context = _tmp3_;
	_tmp4_ = text_style;
	_tmp6_ = granite_text_style_get_stylesheet (_tmp4_, &_tmp5_);
	_g_free0 (style_class);
	style_class = _tmp5_;
	_g_free0 (stylesheet);
	stylesheet = _tmp6_;
	_tmp7_ = style_context;
	_tmp8_ = style_class;
	gtk_style_context_add_class (_tmp7_, _tmp8_);
	{
		GtkCssProvider* _tmp9_;
		const gchar* _tmp10_;
		_tmp9_ = style_provider;
		_tmp10_ = stylesheet;
		gtk_css_provider_load_from_data (_tmp9_, _tmp10_, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* err = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = err;
		_tmp12_ = _tmp11_->message;
		g_warning ("Utils.vala:119: Couldn't apply style to label: %s", _tmp12_);
		_g_error_free0 (err);
		_g_free0 (stylesheet);
		_g_free0 (style_class);
		_g_object_unref0 (style_context);
		_g_object_unref0 (style_provider);
		return;
	}
	__finally21:
	if (_inner_error_ != NULL) {
		_g_free0 (stylesheet);
		_g_free0 (style_class);
		_g_object_unref0 (style_context);
		_g_object_unref0 (style_provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp13_ = style_context;
	_tmp14_ = style_provider;
	gtk_style_context_add_provider (_tmp13_, (GtkStyleProvider*) _tmp14_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_g_free0 (stylesheet);
	_g_free0 (style_class);
	_g_object_unref0 (style_context);
	_g_object_unref0 (style_provider);
}



